#pragma once

class CAddress
{
public:
	CAddress();
	CAddress(int zone, int net, int node, int point, const tstring& domain);
	CAddress(const CAddress& aCopy);
	~CAddress(void);

	CAddress& operator =(const CAddress& address);

	bool parseString(LPCTSTR str);

	// get undefined parts of the address from base address
	void baseUpon(const CAddress& baseAddress);

	tstring toString() const;
	tstring	toStringWithoutDomain() const;
	tstring toShortestString(const CAddress& baseAddr) const;

	// zone

	int		getZone() const		{ return m_zone; }
	void	setZone(int zone)	{ m_zone = zone; }

	// net

	int		getNet() const		{ return m_net; }
	void	setNet(int net)		{ m_net = net;	}

	// node

	int		getNode() const		{ return m_node; }
	void	setNode(int node)	{ m_node = node; }

	// point

	int		getPoint() const	{ return m_point;  }
	void	setPoint(int point)	{ m_point = point; }

	// domain

	const tstring&	getDomain() const					{ return m_domain;   }
	tstring&		getDomain()							{ return m_domain;   }
	void			setDomain(const tstring& domain)	{ m_domain = domain; }

	bool operator ==(const CAddress& address) const;
	bool operator !=(const CAddress& address) const { return !((*this) == address); }

	// address is defined when it is not "-1:-1/-1.-1@"
	bool isDefined() const;

	void undefine() { m_zone = m_net = m_node = m_point = -1; m_domain.clear(); }

protected:
	int				m_zone, m_net, m_node, m_point;
	tstring			m_domain;
};
