#include "pch.h"
#include "FTNStruc.hpp"
#include "Common.h"
#include "Adrenalin.h"

SGlobalVars g_vars;

void SGlobalVars::FreeMsgData() {
	g_vars.m_vMsgData.clear();
}


// SWarnings	g_warnings;
LPCTSTR	c_szForwardsFileName = _T("forwards.lst");


/***************
  CFileFlagBase
 ***************/


CFileFlagBase::CFileFlagBase(const tstring& fileName, bool used /* = false */)
	: m_fileName(fileName), m_originalFileName(fileName), m_used(used)
{
	CAdrenalin::adjustFileName( m_fileName );
}


void CFileFlagBase::setFileName(const tstring& newName) {
	m_originalFileName = newName;
	m_fileName         = newName; 
	CAdrenalin::adjustFileName( m_fileName );
}


/***************
  CCommonData
 ***************/

 
CCommonData::CCommonData()
: CSingleton()
{
	// set default values
	m_useLongAutocreatedPaths = true;
	m_showMustGoOn            = false;
	m_logMsgNames             = false;

	m_useDomainInBSO          = false;

	m_fileListName            = TEXT("files.bbs");
	m_fileListFormat.setFormat( TEXT("%12n %d") );
	m_sortFileList            = false;

	m_killProcessedMail         = false;
	m_replyMessageAttributes    = 0;
	m_replyMessageFlags         = 0;
	m_mailCreationLimitInKBytes = -1;
	m_mailCreationLimitInLines  = -1;
	m_noMailNotifyForBasePurge  = false;

	m_languageFileName  = TEXT("adrenalin.lng");
	m_commonLogFileName = TEXT("adrenalin.log");

	m_forwardExpirationTime = -1;
	m_maxTicAge             = -1;

	m_warnOnIncorrectCRC32   = false;
	m_hatchOriginAddressMain = false;
	m_allAKASeen             = false;
	m_handleReplaces         = false;

	m_notifyOnErrors   = false;
	m_notifyOnWarnings = false;

	m_renameFilePlan = RFP_NONE;
}


bool CCommonData::hasSysopAKA(const CAddress& address) const {
	for (unsigned int i = 0; i < m_sysopAKAs.size(); i++) {
		if (m_sysopAKAs[i] == address) {
			return true;
		}
	}
	return false;
}

bool CCommonData::hasAlias(const tstring& alias) const {
	for (unsigned int i = 0; i < m_aliases.size(); i++) {
		if (lstrcmpi( m_aliases[i].c_str(), alias.c_str() ) == 0) {
			return true;
		}
	}
	return false;
}
