#pragma	once

#include "links.h"
#include <MiniSAX.h>


/*******************************************
  Classes to parse links configuration data
 *******************************************/


using	miniSAX::CMiniSAXException;
using	miniSAX::CContentHandler;
using	miniSAX::CAttribute;
using	miniSAX::CAttributeList;
using	miniSAX::CMiniSAXParser;


class CLinksContentHandler : public CContentHandler {
public:
    CLinksContentHandler(CMiniSAXParser* aParser);
    virtual ~CLinksContentHandler();

    virtual void startElement(const char* name, CAttributeList& attributes)
        throw (CMiniSAXException);
    virtual void endElement(const char* name)
        throw (CMiniSAXException);

    virtual void handleCharacters(const char* buffer, size_t len)
        throw (CMiniSAXException);

protected:
	enum State {
		ROOT_STATE,
		LINKS_STATE,
		LINK_STATE,
		NAME_STATE,
		ADDRESS_STATE,
		OUTBOUND_STATE,
		ALLOW_AREA_CREATION_STATE,
		PATH_STATE,
		DEFAULT_GROUP_STATE,
		AUTOCREATED_SEND_PRIORITY_STATE,
		AUTOCREATED_RECEIVE_PRIORITY_STATE,
		AUTOCREATED_PASSTHROUGH_STATE,
		AUTOCREATED_OPEN_FOR_RESEND_STATE,
		STATUS_STATE,
		ROBOT_NAME_STATE,
		AVAIL_AREAS_STATE,
		USE_AKA_STATE,
		SECURITY_STATE,
		PASSWORD_STATE,
		SEND_PRIORITY_STATE,
		RECEIVE_PRIORITY_STATE,
		GROUP_STATE
	};

	State	state;
	PLink	link;

	CMiniSAXParser*	parser;
};


