#pragma once
#include "minisax.h"

using miniSAX::CAttribute;

class CAttributeImpl : public CAttribute
{
public:
	CAttributeImpl(void) {}
	CAttributeImpl(const char* name, const char* value) : m_name(name), m_value(value) {}
	CAttributeImpl(const CAttribute& instance) : m_name(instance.getName()), m_value(instance.getValue()) {}
	virtual ~CAttributeImpl(void) {}

	virtual CAttributeImpl& operator =(const CAttributeImpl& instance) {
		m_name  = instance.getName();
		m_value = instance.getValue();
		return (*this);
	}

	virtual const char* getName()  const { return m_name.c_str();  }
	virtual const char* getValue() const { return m_value.c_str(); }

protected:
	std::string	m_name;
	std::string	m_value;
};
