#pragma once
#include "minisax.h"
#include "AttributeImpl.h"

using miniSAX::CAttribute;
using miniSAX::CAttributeList;
using miniSAX::CMiniSAXException;

class CAttributeListImpl : public CAttributeList
{
public:
	CAttributeListImpl(void);
	virtual ~CAttributeListImpl(void);

	virtual void addAttribute(const CAttribute& newAttr) { m_attributes.push_back( newAttr ); }
	virtual size_t getCount() const { return m_attributes.size(); }
	virtual const CAttribute* getAttribute(int index) const { return &(m_attributes[index]); }
	virtual const CAttribute* getAttribute(const char* name);
	virtual const CAttribute* getAttribute(const char* name, size_t n);

	virtual void checkUnexpected() throw(CMiniSAXException);
protected:
	std::vector<CAttributeImpl>	m_attributes;
	std::vector<std::string>	m_requestedNames;
};
